org.springframework.cache.ehcache

## Class EhCacheFactoryBean

- java.lang.Object
- - net.sf.ehcache.config.CacheConfiguration
  - - org.springframework.cache.ehcache.EhCacheFactoryBean

- All Implemented Interfaces:
    Cloneable, Aware, BeanNameAware, FactoryBean<Ehcache>, InitializingBean

      public class EhCacheFactoryBean
      extends CacheConfiguration
      implements FactoryBean<Ehcache>, BeanNameAware, InitializingBean

  `FactoryBean` that creates a named EhCache `Cache` instance (or a decorator that implements the `Ehcache` interface), representing a cache region within an EhCache `CacheManager`.

  If the specified named cache is not configured in the cache configuration descriptor, this FactoryBean will construct an instance of a Cache with the provided name and the specified cache properties and add it to the CacheManager for later retrieval. If some or all properties are not set at configuration time, this FactoryBean will use defaults.

  Note: If the named Cache instance is found, the properties will be ignored and the Cache instance will be retrieved from the CacheManager.

  Note: As of Spring 4.0, Spring's EhCache support requires EhCache 2.1 or higher. We recommend the use of EhCache 2.5 or higher.

  Since:
    1.1.1
  Author:
    Juergen Hoeller, Dmitriy Kopylenko
  See Also:
    `setCacheManager(net.sf.ehcache.CacheManager)`, `EhCacheManagerFactoryBean`, `Cache`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.ehcache.config.CacheConfiguration

      `CacheConfiguration.BootstrapCacheLoaderFactoryConfiguration, CacheConfiguration.CacheDecoratorFactoryConfiguration, CacheConfiguration.CacheEventListenerFactoryConfiguration, CacheConfiguration.CacheExceptionHandlerFactoryConfiguration, CacheConfiguration.CacheExtensionFactoryConfiguration, CacheConfiguration.CacheLoaderFactoryConfiguration, CacheConfiguration.TransactionalMode`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Log` | `logger`

    - ### Fields inherited from class net.sf.ehcache.config.CacheConfiguration

      `bootstrapCacheLoaderFactoryConfiguration, cacheDecoratorConfigurations, cacheEventListenerConfigurations, cacheExceptionHandlerFactoryConfiguration, cacheExtensionConfigurations, cacheLoaderConfigurations, cacheLoaderTimeoutMillis, cacheWriterConfiguration, clearOnFlush, DEFAULT_CACHE_WRITER_CONFIGURATION, DEFAULT_CLEAR_ON_FLUSH, DEFAULT_COPY_ON_READ, DEFAULT_COPY_ON_WRITE, DEFAULT_COPY_STRATEGY_CONFIGURATION, DEFAULT_DISK_ACCESS_STRIPES, DEFAULT_DISK_PERSISTENT, DEFAULT_ETERNAL_VALUE, DEFAULT_EXPIRY_THREAD_INTERVAL_SECONDS, DEFAULT_LOGGING, DEFAULT_MAX_BYTES_OFF_HEAP, DEFAULT_MAX_BYTES_ON_DISK, DEFAULT_MAX_BYTES_ON_HEAP, DEFAULT_MAX_ELEMENTS_ON_DISK, DEFAULT_MEMORY_STORE_EVICTION_POLICY, DEFAULT_SPOOL_BUFFER_SIZE, DEFAULT_STATISTICS, DEFAULT_TRANSACTIONAL_MODE, DEFAULT_TTI, DEFAULT_TTL, diskAccessStripes, diskExpiryThreadIntervalSeconds, diskPersistent, diskSpoolBufferSizeMB, eternal, listeners, logging, maxElementsOnDisk, maxEntriesLocalHeap, memoryStoreEvictionPolicy, name, overflowToDisk, overflowToOffHeap, pinningConfiguration, terracottaConfiguration, timeToIdleSeconds, timeToLiveSeconds`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EhCacheFactoryBean()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `protected Cache` | `createCache()` Create a raw Cache object based on the configuration of this FactoryBean.
    `protected Ehcache` | `decorateCache(Ehcache cache)` Decorate the given Cache, if necessary.
    `Ehcache` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends Ehcache>` | `getObjectType()` Predict the particular `Ehcache` implementation that will be returned from `getObject()` based on logic in `createCache()` and `decorateCache(Ehcache)` as orchestrated by `afterPropertiesSet()`.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setBeanName(String name)` Set the name of the bean in the bean factory that created this bean.
    `void` | `setBlocking(boolean blocking)` Set whether to use a blocking cache that lets read attempts block until the requested element is created.
    `void` | `setBootstrapCacheLoader(BootstrapCacheLoader bootstrapCacheLoader)` Set an EhCache `BootstrapCacheLoader` for this cache, if any.
    `void` | `setCacheEntryFactory(CacheEntryFactory cacheEntryFactory)` Set an EhCache `CacheEntryFactory` to use for a self-populating cache.
    `void` | `setCacheEventListeners(Set<CacheEventListener> cacheEventListeners)` Specify EhCache `cache event listeners` to registered with this cache.
    `void` | `setCacheManager(CacheManager cacheManager)` Set a CacheManager from which to retrieve a named Cache instance.
    `void` | `setCacheName(String cacheName)` Set a name for which to retrieve or create a cache instance.
    `void` | `setDisabled(boolean disabled)` Set whether this cache should be marked as disabled.
    `void` | `setDiskSpoolBufferSize(int diskSpoolBufferSize)`
    `void` | `setSampledStatisticsEnabled(boolean sampledStatisticsEnabled)` Set whether to enable EhCache's sampled statistics on this cache.
    `void` | `setStatisticsEnabled(boolean statisticsEnabled)` Set whether to enable EhCache statistics on this cache.
    `void` | `setTimeToIdle(int timeToIdle)`
    `void` | `setTimeToLive(int timeToLive)`

    - ### Methods inherited from class net.sf.ehcache.config.CacheConfiguration

      `addBootstrapCacheLoaderFactory, addCacheDecoratorFactory, addCacheEventListenerFactory, addCacheExceptionHandlerFactory, addCacheExtensionFactory, addCacheLoaderFactory, addCacheWriter, addConfigurationListener, addCopyStrategy, addDynamicSearchListener, addElementValueComparator, addPersistence, addPinning, addSearchable, addSizeOfPolicy, addTerracotta, bootstrapCacheLoaderFactory, cacheEventListenerFactory, cacheExceptionHandlerFactory, cacheExtensionFactory, cacheLoaderFactory, cacheWriter, clearOnFlush, clone, copyOnRead, copyOnWrite, diskAccessStripes, diskExpiryThreadIntervalSeconds, diskPersistent, diskSpoolBufferSizeMB, dynamicAttributeExtractor, eternal, freezeConfiguration, getBootstrapCacheLoaderFactoryConfiguration, getCacheDecoratorConfigurations, getCacheEventListenerConfigurations, getCacheExceptionHandlerFactoryConfiguration, getCacheExtensionConfigurations, getCacheLoaderConfigurations, getCacheLoaderTimeoutMillis, getCacheWriterConfiguration, getCopyStrategy, getCopyStrategyConfiguration, getDiskAccessStripes, getDiskExpiryThreadIntervalSeconds, getDiskSpoolBufferSizeMB, getDynamicExtractor, getElementValueComparatorConfiguration, getLogging, getMaxBytesLocalDisk, getMaxBytesLocalDiskAsString, getMaxBytesLocalDiskPercentage, getMaxBytesLocalHeap, getMaxBytesLocalHeapAsString, getMaxBytesLocalHeapPercentage, getMaxBytesLocalOffHeap, getMaxBytesLocalOffHeapAsString, getMaxBytesLocalOffHeapPercentage, getMaxElementsInMemory, getMaxElementsOnDisk, getMaxEntriesLocalDisk, getMaxEntriesLocalHeap, getMaxMemoryOffHeap, getMaxMemoryOffHeapInBytes, getMemoryStoreEvictionPolicy, getName, getPersistenceConfiguration, getPinningConfiguration, getSearchable, getSearchAttributes, getSizeOfPolicyConfiguration, getStatistics, getTerracottaConfiguration, getTerracottaConsistency, getTimeToIdleSeconds, getTimeToLiveSeconds, getTransactionalMode, internalSetDiskCapacity, internalSetLogging, internalSetMemCapacity, internalSetMemCapacityInBytes, internalSetTimeToIdle, internalSetTimeToLive, isClearOnFlush, isCopyOnRead, isCopyOnWrite, isCountBasedTuned, isDiskPersistent, isEternal, isFrozen, isLocalTransactional, isMaxBytesLocalDiskPercentageSet, isMaxBytesLocalHeapPercentageSet, isMaxBytesLocalOffHeapPercentageSet, isOverflowToDisk, isOverflowToOffHeap, isOverflowToOffHeapSet, isSearchable, isTerracottaClustered, isXaStrictTransactional, isXaTransactional, logging, maxBytesLocalDisk, maxBytesLocalHeap, maxBytesLocalOffHeap, maxElementsInMemory, maxElementsOnDisk, maxEntriesLocalDisk, maxEntriesLocalHeap, maxMemoryOffHeap, memoryStoreEvictionPolicy, memoryStoreEvictionPolicy, name, overflowToDisk, overflowToOffHeap, persistence, pinning, removeConfigurationListener, searchable, setCacheLoaderTimeoutMillis, setClearOnFlush, setCopyOnRead, setCopyOnWrite, setDiskAccessStripes, setDiskExpiryThreadIntervalSeconds, setDiskPersistent, setDiskSpoolBufferSizeMB, setDynamicAttributesExtractor, setEternal, setLogging, setMaxBytesLocalDisk, setMaxBytesLocalDisk, setMaxBytesLocalHeap, setMaxBytesLocalHeap, setMaxBytesLocalOffHeap, setMaxBytesLocalOffHeap, setMaxElementsInMemory, setMaxElementsOnDisk, setMaxEntriesLocalDisk, setMaxEntriesLocalHeap, setMaxMemoryOffHeap, setMemoryStoreEvictionPolicy, setMemoryStoreEvictionPolicyFromObject, setName, setOverflowToDisk, setOverflowToOffHeap, setStatistics, setTimeToIdleSeconds, setTimeToLiveSeconds, setTransactionalMode, setupFor, setupFor, sizeOfPolicy, statistics, terracotta, timeoutMillis, timeToIdleSeconds, timeToLiveSeconds, transactionalMode, transactionalMode, validate, validateCompleteConfiguration, validateConfiguration`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected final Log logger

  - ### Constructor Detail

    - #### EhCacheFactoryBean

          public EhCacheFactoryBean()

  - ### Method Detail

    - #### setCacheManager

          public void setCacheManager(CacheManager cacheManager)

      Set a CacheManager from which to retrieve a named Cache instance. By default, `CacheManager.getInstance()` will be called.

      Note that in particular for persistent caches, it is advisable to properly handle the shutdown of the CacheManager: Set up a separate EhCacheManagerFactoryBean and pass a reference to this bean property.

      A separate EhCacheManagerFactoryBean is also necessary for loading EhCache configuration from a non-default config location.

      See Also:
        `EhCacheManagerFactoryBean`, `CacheManager.getInstance()`

    - #### setCacheName

          public void setCacheName(String cacheName)

      Set a name for which to retrieve or create a cache instance. Default is the bean name of this EhCacheFactoryBean.

    - #### setTimeToLive

          public void setTimeToLive(int timeToLive)

      See Also:
        `CacheConfiguration.setTimeToLiveSeconds(long)`

    - #### setTimeToIdle

          public void setTimeToIdle(int timeToIdle)

      See Also:
        `CacheConfiguration.setTimeToIdleSeconds(long)`

    - #### setDiskSpoolBufferSize

          public void setDiskSpoolBufferSize(int diskSpoolBufferSize)

      See Also:
        `CacheConfiguration.setDiskSpoolBufferSizeMB(int)`

    - #### setBlocking

          public void setBlocking(boolean blocking)

      Set whether to use a blocking cache that lets read attempts block until the requested element is created.

      If you intend to build a self-populating blocking cache, consider specifying a `CacheEntryFactory`.

      See Also:
        `BlockingCache`, `setCacheEntryFactory(net.sf.ehcache.constructs.blocking.CacheEntryFactory)`

    - #### setCacheEntryFactory

          public void setCacheEntryFactory(CacheEntryFactory cacheEntryFactory)

      Set an EhCache `CacheEntryFactory` to use for a self-populating cache. If such a factory is specified, the cache will be decorated with EhCache's `SelfPopulatingCache`.

      The specified factory can be of type `UpdatingCacheEntryFactory`, which will lead to the use of an `UpdatingSelfPopulatingCache`.

      Note: Any such self-populating cache is automatically a blocking cache.

      See Also:
        `SelfPopulatingCache`, `UpdatingSelfPopulatingCache`, `UpdatingCacheEntryFactory`

    - #### setBootstrapCacheLoader

          public void setBootstrapCacheLoader(BootstrapCacheLoader bootstrapCacheLoader)

      Set an EhCache `BootstrapCacheLoader` for this cache, if any.

    - #### setCacheEventListeners

          public void setCacheEventListeners(Set<CacheEventListener> cacheEventListeners)

      Specify EhCache `cache event listeners` to registered with this cache.

    - #### setStatisticsEnabled

          public void setStatisticsEnabled(boolean statisticsEnabled)

      Set whether to enable EhCache statistics on this cache.

      Note: As of EhCache 2.7, statistics are enabled by default, and cannot be turned off. This setter therefore has no effect in such a scenario.

      See Also:
        `Ehcache.setStatisticsEnabled(boolean)`

    - #### setSampledStatisticsEnabled

          public void setSampledStatisticsEnabled(boolean sampledStatisticsEnabled)

      Set whether to enable EhCache's sampled statistics on this cache.

      Note: As of EhCache 2.7, statistics are enabled by default, and cannot be turned off. This setter therefore has no effect in such a scenario.

      See Also:
        `Ehcache.setSampledStatisticsEnabled(boolean)`

    - #### setDisabled

          public void setDisabled(boolean disabled)

      Set whether this cache should be marked as disabled.
      See Also:
        `Cache.setDisabled(boolean)`

    - #### setBeanName

          public void setBeanName(String name)

      Description copied from interface: `BeanNameAware`
      Set the name of the bean in the bean factory that created this bean.

      Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

      Specified by:
        `setBeanName` in interface `BeanNameAware`
      Parameters:
        `name` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

    - #### afterPropertiesSet

          public void afterPropertiesSet()
                                  throws CacheException,
                                         IOException

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`
      Throws:
        `CacheException`
        `IOException`

    - #### createCache

          protected Cache createCache()

      Create a raw Cache object based on the configuration of this FactoryBean.

    - #### decorateCache

          protected Ehcache decorateCache(Ehcache cache)

      Decorate the given Cache, if necessary.
      Parameters:
        `cache` - the raw Cache object, based on the configuration of this FactoryBean
      Returns:
        the (potentially decorated) cache object to be registered with the CacheManager

    - #### getObject

          public Ehcache getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<Ehcache>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends Ehcache> getObjectType()

      Predict the particular `Ehcache` implementation that will be returned from `getObject()` based on logic in `createCache()` and `decorateCache(Ehcache)` as orchestrated by `afterPropertiesSet()`.
      Specified by:
        `getObjectType` in interface `FactoryBean<Ehcache>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<Ehcache>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`